#pragma once

#include <GLFW/glfw3.h>
#include "quark/Window.hpp"

namespace qk {
	class LinuxWindow :
		public Window
	{
	public:
		LinuxWindow(const WindowConfig& config);
		virtual ~LinuxWindow();

		void OnUpdate() override;

		inline unsigned int GetWidth() const override { return data.width; }
		inline unsigned int GetHeight() const override { return data.height; }

		inline void SetEventCallback(const EventCallbackFn& callback) override { data.eventCallback = callback; }
		constexpr void SetVSync(bool enable) override;
		bool HasVSync() const override;

	private:
		void Init(const WindowConfig& config);
		void Destroy();

		void InstallGLFWCallbacks();

	private:
		GLFWwindow* window;

		struct WindowData {
			std::string title;
			unsigned int width, height;
			bool vsync;

			EventCallbackFn eventCallback;
		} data;
	};
}
